package com.ccnode.codegenerator.mybatisGenerator.plugins.tools;

package .tmp;

import java.util.Iterator;
import java.util.List;
import java.util.TreeSet;
import org.mybatis.generator.api.CommentGenerator;
import org.mybatis.generator.api.IntrospectedTable;
import org.mybatis.generator.api.dom.java.FullyQualifiedJavaType;
import org.mybatis.generator.api.dom.java.InnerClass;
import org.mybatis.generator.api.dom.java.InnerEnum;
import org.mybatis.generator.api.dom.java.Interface;
import org.mybatis.generator.api.dom.java.Method;
import org.mybatis.generator.api.dom.java.Parameter;
import org.mybatis.generator.api.dom.java.TopLevelClass;
import org.mybatis.generator.api.dom.xml.Attribute;
import org.mybatis.generator.api.dom.xml.Element;
import org.mybatis.generator.api.dom.xml.TextElement;
import org.mybatis.generator.api.dom.xml.XmlElement;

public class FormatTools {
  public static void a(InnerClass paramInnerClass, Method paramMethod) {
    a(paramMethod, paramInnerClass.getMethods());
  }
  
  public static void a(Interface paramInterface, Method paramMethod) {
    TreeSet<FullyQualifiedJavaType> treeSet = new TreeSet();
    if (paramMethod.getReturnType() != null) {
      treeSet.add(paramMethod.getReturnType());
      treeSet.addAll(paramMethod.getReturnType().getTypeArguments());
    } 
    for (Parameter parameter : paramMethod.getParameters()) {
      boolean bool = true;
      for (String str : parameter.getAnnotations()) {
        if (str.startsWith("@Param"))
          treeSet.add(new FullyQualifiedJavaType("org.apache.ibatis.annotations.Param")); 
      } 
      if (bool) {
        treeSet.add(parameter.getType());
        treeSet.addAll(parameter.getType().getTypeArguments());
      } 
    } 
    paramInterface.addImportedTypes(treeSet);
    a(paramMethod, paramInterface.getMethods());
  }
  
  public static void a(InnerEnum paramInnerEnum, Method paramMethod) {
    a(paramMethod, paramInnerEnum.getMethods());
  }
  
  public static void a(TopLevelClass paramTopLevelClass, Method paramMethod) {
    a(paramMethod, paramTopLevelClass.getMethods());
  }
  
  public static void a(XmlElement paramXmlElement1, XmlElement paramXmlElement2) {
    if (paramXmlElement2.getName().equals("sql")) {
      byte b = 0;
      for (Element element : paramXmlElement1.getElements()) {
        if (element instanceof XmlElement && ((XmlElement)element).getName().equals("sql"))
          b++; 
      } 
      paramXmlElement1.addElement(b, (Element)paramXmlElement2);
    } else {
      String str = a(paramXmlElement2);
      if (str == null) {
        paramXmlElement1.addElement((Element)paramXmlElement2);
      } else {
        List<Element> list = paramXmlElement1.getElements();
        int i = -1;
        for (byte b = 0; b < list.size(); b++) {
          Element element = list.get(b);
          if (element instanceof XmlElement) {
            String str1 = a((XmlElement)element);
            if (str1 != null)
              if (str1.startsWith(str)) {
                if (i == -1)
                  i = b; 
              } else if (str.startsWith(str1)) {
                i = b + 1;
              }  
          } 
        } 
        if (i == -1 || i >= list.size()) {
          paramXmlElement1.addElement((Element)paramXmlElement2);
        } else {
          list.add(i, paramXmlElement2);
        } 
      } 
    } 
  }
  
  private static String a(XmlElement paramXmlElement) {
    for (Attribute attribute : paramXmlElement.getAttributes()) {
      if (attribute.getName().equals("id"))
        return attribute.getValue(); 
    } 
    return null;
  }
  
  private static void a(Method paramMethod, List<Method> paramList) {
    int i = -1;
    for (byte b = 0; b < paramList.size(); b++) {
      Method method = paramList.get(b);
      if (method.getName().equals(paramMethod.getName())) {
        if (method.getParameters().size() <= paramMethod.getParameters().size()) {
          i = b + 1;
        } else {
          i = b;
        } 
      } else if (method.getName().startsWith(paramMethod.getName())) {
        if (i == -1)
          i = b; 
      } else if (paramMethod.getName().startsWith(method.getName())) {
        i = b + 1;
      } 
    } 
    if (i == -1 || i >= paramList.size()) {
      paramList.add(paramList.size(), paramMethod);
    } else {
      paramList.add(i, paramMethod);
    } 
  }
  
  public static void a(CommentGenerator paramCommentGenerator, Method paramMethod, IntrospectedTable paramIntrospectedTable) {
    paramMethod.getJavaDocLines().clear();
    paramCommentGenerator.addGeneralMethodComment(paramMethod, paramIntrospectedTable);
  }
  
  public static void a(CommentGenerator paramCommentGenerator, XmlElement paramXmlElement) {
    Iterator<Element> iterator = paramXmlElement.getElements().iterator();
    boolean bool = false;
    while (iterator.hasNext()) {
      Element element = iterator.next();
      if (element instanceof TextElement && ((TextElement)element).getContent().matches("<!--"))
        bool = true; 
      if (bool)
        iterator.remove(); 
      if (element instanceof TextElement && ((TextElement)element).getContent().matches("-->"))
        bool = false; 
    } 
    XmlElement xmlElement = new XmlElement("tmp");
    paramCommentGenerator.addComment(xmlElement);
    for (int i = xmlElement.getElements().size() - 1; i >= 0; i--)
      paramXmlElement.addElement(0, xmlElement.getElements().get(i)); 
  }
}
